/*
 *  Configuration table information
 */

#ident	"conf.c:  Sat May 27 11:27:14 1995. VER: 25.1"

#include	"config.h"


/* %CONFIG from m.d/kernel */


#include	"sys/param.h"
#include	"sys/types.h"
#include	"sys/sysmacros.h"
#include	"sys/signal.h"
#include	"sys/fs/s5dir.h"
#include	"sys/user.h"
#include	"sys/stream.h"
#include	"sys/conf.h"
#include	"sys/errno.h"
#include	"sys/acct.h"
#include	"sys/tty.h"
#include	"sys/termio.h"
#include	"sys/buf.h"
#include	"sys/file.h"
#include	"sys/inode.h"
#include	"sys/region.h"
#include	"sys/proc.h"
#include	"sys/map.h"
#include	"sys/callo.h"
#include	"sys/mount.h"
#include	"sys/elog.h"
#include	"sys/err.h"
#include	"sys/iobuf.h"
#include	"sys/utsname.h"
#include	"sys/opt.h"
#include	"sys/var.h"
#include	"sys/fcntl.h"
#include	"sys/fstyp.h"
#include	"sys/flock.h"
#include	"sys/message.h"
#include	"sys/tuneable.h"
#include	"sys/fs/s5inode.h"
#include	"sys/nami.h"
#include	"sys/sysinfo.h"
#include	"sys/open.h"
#include	"sys/resource.h"


struct	buf	bfreelist;		/* head of the free list of buffers */
struct	buf	bdirtylist;		/* head of the list of dirty buffers */
struct	pfree	pfreelist;		/* Head of physio header pool */
struct	buf	pbuf[NPBUF];		/* Physical io header pool */
struct  buf 	bufhdrs[NBUF];		/* buffer headers */
struct	hbuf	hbuf[NHBUF];		/* buffer hash table */
char		*buffers;		/* buffer data */

struct	file	file[NFILE];		/* file table */

struct	inode	inode[NINODE];		/* inode table */
struct	s5inode	s5inode[NS5INODE];	/* s5inode table */
struct hinode	hinode[NHINO];		/* The inode hash table	*/
int		hinodemask = NHINO - 1;	/* its mask for hashing	*/
uint		isyn_flag = ISYN_FLAG;
uint		isyn;
struct	locklist locklist[NFLOCKS];	/* lock table */
struct flckinfo	flckinfo = {		/* lockf accounting */
	FLCKREC, 0, 0, 0 
};
struct filock	flox[FLCKREC];		/* lockf table */

int	fips = 1; 			/* fips compatability flag */

#ifdef INODE_DEBUG
/* inode logging */
struct ilog {
	struct inode	*il_addr;
	struct inode	*il_forw;
	struct inode	*il_back;
	struct inode	*il_avforw;
	struct inode	*il_avback;
	int		*il_fsptr;
	long		il_number;
	struct rcvd	*il_rcvd;
	short		il_fstyp;
	dev_t		il_dev;
	cnt_t		il_count;
	short		il_op;
	int		*il_caller;
};

struct ilog	ilogs[ILOGSIZE];
int		ilogsize = sizeof(ilogs) / sizeof(*ilogs);
#endif /* INODE_DEBUG */

struct	proc	proc[NPROC];		/* process table */
struct  region	region[NREGION];	/* region descriptor table */
struct	auth  	ua[NPROC];		/* usr authorization stuff */


struct	callo	callout[NCALL], *callfree, calltodo;
struct	map	sptmap[SPTMAP];

struct	mount	mount[NMOUNT];

struct shlbinfo shlbinfo = {
		SHLBMAX,
		0,
		0
};

/* printf internal buffer not used (naw 10/20)
char	putbuf[PUTBUFSZ];
int	putbufsz;
 */

struct sysinfo	sysinfo;
struct syserr	syserr;

tune_t	tune = {
		GPGSLO,
		GPGSHI,
		GPGSMSK,
		VHANDR,
		VHANDL,
		MAXSC,
		MAXFC,
		MAXUMEM,
		BDFLUSHR,
		BDFLUSHR,
		MINARMEM,
		MINASMEM,
		BDIRTYPCT,
		BASYNCHI,
		BASYNCLO,
 		S54KBDIRTYPCT,
 		S54KBASYNCHI,
 		S54KBASYNCLO
};

int	quantum_size	 = QUANTUMSIZE;
int	max_quantum_size = MAXHARDSLICE;
int	max_slice_clamp	 = MAXHARDSLICE;
int	max_pri_clamp	 = MAXHARDPRI;
int	max_usrpri_clamp = MAXHARDUSRPRI;
int	max_cpu_clamp	 = MAXHARDCPU;
int	max_pri_adj	 = MAXPRIADJ;

struct	cblock	cfree[NCLIST];

#ifdef TRACE_0
#	include	"sys/trace.h"
	struct	trace	trace[TRACE_0 * TRACE_0_PHYS];
#endif

struct	var	v = {
	NBUF,
	NCALL,
	NINODE,
	(char *)(&inode[NINODE]),
	NFILE,
	(char *)(&file[NFILE]),
	NMOUNT,
	(char *)(&mount[NMOUNT]),
	NPROC,
	(char *)(&proc[1]),
	NREGION,
	NCLIST,
	MAXUP,
	NHBUF,
	NHBUF-1,
	NPBUF,
	SPTMAP,
	VHNDFRAC,
	0,
	NAUTOUP,
	NAUTOUP * HZ,
	SFNOLIM,

	NQUEUE,
	NSTREAM,
	NBLK4096,
	NBLK2048,
	NBLK1024,
	NBLK512,
	NBLK256,
	NBLK128,
	NBLK64,
	NBLK16,
	NBLK4,
	CDLIMIT_CONF,
	NS5INODE,
	NFLOCKS,
	NGROUPS_MAX
};


short   ipid[NINODE];

#if !defined(NUM_SWAPBUF) || NUM_SWAPBUF <= 0
#define NUM_SWAPBUF	4
#endif
/* buf structures for use by the swap function */
buf_t	swap_bufs[NUM_SWAPBUF];
buf_t	swapfreelist;
int	numswap_bufs = sizeof(swap_bufs) / sizeof(*swap_bufs);

dev_t	rootdev, pipedev, swapdev;		/* set at kernel boot */

extern	nodev(), nulldev();

#ifdef VT_VT100
extern  vt100input(), vt100output(), vt100ioctl();
#endif
#ifdef VT_HP45
extern  hp45input(), hp45output(), hp45ioctl();
#endif
struct termsw termsw[] = {
	nulldev, nulldev, nulldev, /* tty */
#ifdef VT_VT100
	vt100input, vt100output, vt100ioctl, /* VT100 */
#else
	nulldev, nulldev, nulldev,
#endif
#ifdef VT_HP45
	hp45input, hp45output, hp45ioctl, /* HP45 */
#else
	nulldev, nulldev, nulldev,
#endif
};
int	termcnt = sizeof(termsw) / sizeof(struct termsw);

/* misc. */
int	hz = HZ;

extern int	cinit(), binit(), iinit(), inoinit();
extern int	fsinit();
extern int	finit(), flckinit();
extern int 	strinit();
extern int	errinit();
extern int	msginit();
extern int	seminit();
extern int	shminit();
extern int	errinit();
extern int	initswapbufs();
extern int	coninit();
extern int	spm2kerninit();
extern int	disable_interrupts_init();

/*	Array containing the addresses of the various initializing	*/
/*	routines executed by "main" at boot time.			*/

int (*init_tbl[])() = {
	cinit,
	inoinit,
	fsinit,
	finit,
	binit,
	iinit,
	flckinit,
	strinit,
	msginit,
	seminit,
	shminit,
	errinit,
	initswapbufs,
	coninit,
	spm2kerninit,
	disable_interrupts_init,
	(int (*)())0
};

struct utsname utsname = {
	"ARIX_OS",			/* system name			*/
	NODE,				/* node name on networks	*/
	"2:3.3-08",			/* release (CPU:product-kernel)	*/
	VERSION,			/* version: supplied by make	*/
	"System90",			/* machine (hardware ID)	*/
};

#ifndef NSRMOUNT
struct srmnt	srmount[1];
#endif

rlimit_t	default_rlimits[] = {
	/* 0 */	0, 0,		
	/* 1 */	0, 0,
	/* 2 */	0, 0,
	/* 3 */	0, 0,
	/* 4 */	0, 0,
	/* 5 */	SFNOLIM, HFNOLIM,
	/* 6 */	0, 0 
};


/* %CONFIG from m.d/msg */


#ifdef MESG
#	include	"sys/ipc.h"
#	include	"sys/msg.h"
	struct map	msgmap[MSGMAP];
	struct msqid_ds	msgque[MSGMNI];
	struct msg	msgh[MSGTQL];
	char		msglock[MSGMNI];
	struct msginfo	msginfo = {
		MSGMAP, MSGMAX, MSGMNB, MSGMNI, MSGSSZ, MSGTQL, MSGSEG
	};
#endif


/* %CONFIG from m.d/sem */


#ifdef SEMA
#	ifndef IPC_ALLOC
#		include	"sys/ipc.h"
#	endif
#	include	"sys/sem.h"
	struct	semid_ds sema[SEMMNI];
	struct	sem	sem[SEMMNS];
	struct	map	semmap[SEMMAP];
	struct	sem_undo *sem_undo[NPROC];
#	define	SEMUSZ	(sizeof(struct sem_undo)+sizeof(struct undo)*SEMUME)
	int		semu[ ( ( SEMUSZ * SEMMNU ) + NBPW - 1 ) / NBPW ];
	union {
		short		semvals[SEMMSL];
		struct	semid_ds ds;
		struct	sembuf	semops[SEMOPM];
	} semtmp;

	struct	seminfo	seminfo = {
		SEMMAP, SEMMNI, SEMMNS, SEMMNU, SEMMSL,
		SEMOPM, SEMUME, SEMUSZ, SEMVMX, SEMAEM
	};
#endif


/* %CONFIG from m.d/shm */


#ifdef SHMEM
#	ifndef	SYS_IPC_H
#		include	"sys/ipc.h"
#	endif
#	include	"sys/shm.h"

	struct shmid_ds	shmem[SHMMNI];	
	suspend_lock_t	shmlk[SHMMNI];	
	struct shminfo	shminfo = {
		SHMMAX, SHMMIN, SHMMNI, SHMSEG, SHMBRK, SHMALL
	};
#else /* SHMEM */
	struct shmid_ds	shmem[1];	
	suspend_lock_t	shmlk[1];	
	struct shminfo	shminfo = {
		SHMMAX, SHMMIN, 1, SHMSEG, SHMBRK, SHMALL
	};
#endif /* SHMEM */

/* %CONFIG from m.d/stream */


		/* N_MSG_BLKS macro - Number of message blocks */
#define	N_MSG_BLKS (NBLK4096+NBLK2048+NBLK1024+ \
			    NBLK512+NBLK256+NBLK128+NBLK64+NBLK16+NBLK4)
#ifndef NEL
#define NEL(x)	(sizeof(x) / sizeof(*x))
#endif

queue_t queue[NQUEUE];			/* table of queues */
struct stdata streams[NSTREAM];		/* table of streams */
mblk_t mblock[(N_MSG_BLKS * 5) / 4];	/* table of message block descriptors */
					/* (125% of N_MSG_BLKS) 	      */

dblk_t dblock[N_MSG_BLKS];	 	/* table of data blk desc */

int	strbase[NBLK4096*1024 + NBLK2048*512 + NBLK1024*256 + NBLK512*128
		+ NBLK256*64 + NBLK128*32 + NBLK64*16 + NBLK16*4 + NBLK4];

struct linkblk linkblk[NMUXLINK];	/* multiplexor link table */
struct strevent strevent[NSTREVENT];	/* table of stream event cells */

int	nmuxlink	= NEL(linkblk);	/* number of multiplexor links */
int	nstrpush  	= NSTRPUSH;	/* maxmimum number of pushes allowed */
int	nstrevent	= NEL(strevent);/* # of stream events */
int	maxsepgcnt  	= MAXSEPGCNT;	/* page limit for event cell alloc */
int	strmsgsz  	= STRMSGSZ;	/* maximum stream message size */
int	strctlsz  	= STRCTLSZ;	/* max size of ctl part of message */
char	strlofrac  	= STRLOFRAC;	/* # of buffers fo low pri. msgs. */
char	strmedfrac  	= STRMEDFRAC;	/* # of buffers fo high pri. msgs. */
int	nmblock		= NEL(mblock);	/* number of msg blk desc */


/* %CONFIG from m.d/iopmb */


uint	iopmb_major = C_IOPMB;

/* %CONFIG from m.d/con */


char		conline = L_CON;
unsigned short	condev = C_CON;

/* %CONFIG from m.d/errlog */


#ifdef ERRLOG_0
#	include	"sys/err.h"
struct	err	err = {
	NESLOT
};
#endif

/* %CONFIG from m.d/log */


#ifdef LOG_0
/* stream log device	*/
#include "sys/log.h"

struct log	log_log[NUM_LOGS];	/* sad device state table */
					/* configured minor devices */
int		log_cnt = sizeof(log_log) / sizeof(*log_log);
int		log_bsz = LOG_BSZ;	/* max length of streams logger queue */
#endif /* LOG_0 */

/* %CONFIG from m.d/mirror */


#ifndef SYS_BUF_H
#include "sys/buf.h"
#endif

#ifndef SYS_SYNCH_H
#include "sys/synch.h"
#endif

#ifndef SYS_VD_H
#include "sys/vd.h"
#endif

#ifdef MIRROR_0
buf_t		mrbufhdrs[NMRBUF];
uint		num_mr_bufs = NMRBUF;
mirror_t	mr_data[MAX_MR_SLICES];
uint		max_mr_data = MAX_MR_SLICES;
ushort		mr_tab[MAX_MR_DEV];
uint		max_mr_devs = MAX_MR_DEV;
#else
mirror_t	mr_data[1];
#endif /* MIRROR_0 */

/* %CONFIG from m.d/prf */


#ifdef PRF_0
	int		maxprf = PRFMAX;
	unsigned	prfctr[PRFMAX + 1];
	unsigned	prfsym[PRFMAX];
#else
	prfintr(){}
#endif

/* %CONFIG from m.d/sat */

#ifdef SAT_0
uchar	sat_buf[SATSIZE];	
uint	sat_size = SATSIZE;
ushort	sat_hwm = SATHWM;
ushort	sat_hz = SATCOUT;
#endif

/* %CONFIG from m.d/sec */


#ifdef SEC_0
#ifndef SYS_SEC_H
#include "sys/security.h"
#endif

#ifndef SYS_MLS_H
#include "sys/mls.h"
#endif

/* sec_mode - the is the security options mode bits. They 
 * describe the current security configuration! They are configurable
 * via the /etc/system file.
 */ 
uint sec_mode = (MACINHERIT<<3 | MACMODE<<2 | PRIVMODE<<1 | SATMODE);

/* sys_priv_mask - this is a global privilege mask. It can be reset
 * through the priv system call to restrict operating privileges processes
 * may inherit. It must start at P_ALL for init and su to function
 * at boottime
 */
uint sys_priv_mask = P_ALL;

kern_role_t kern_role[MAXROLES];
int rolemax = MAXROLES;
int rolesize = sizeof( kern_role_t );

kern_uidmap_t kern_uidmap[MAXUIDS];
int uidmax = MAXUIDS;
int uidsize = sizeof( kern_uidmap_t );

kern_gidmap_t kern_gidmap[MAXGIDS];
int gidmax = MAXGIDS;
int gidsize = sizeof( kern_gidmap_t );

slabel_t exec_labels[MAXEXECL];
int execmax = MAXEXECL;
int execsize = sizeof( slabel_t );
#endif /* SEC_0 */


/* %CONFIG from m.d/sp */


#ifdef SP_0
struct sp_sp {
	long a,b;
} sp_sp[SP_0_DEV];
int	spcnt = sizeof(sp_sp) / sizeof(*sp_sp);
#endif

/* %CONFIG from m.d/vd */


#ifdef VD_0

#	ifndef SYS_BUF_H
#	include "sys/buf.h"
#	endif

#	ifndef SYS_SYNCH_H
#	include "sys/synch.h"
#	endif

#	ifndef SYS_VD_H
#	include "sys/vd.h"
#	endif

vd_t		virt_slices[MAX_VIRT_DISKS];
uint		max_virt_slices = MAX_VIRT_DISKS;
buf_t		vdbufhdrs[NVBUF];
uint		num_vd_bufs = NVBUF;

#endif /* VD_0 */

/* %CONFIG from m.d/spt */


/* %CONFIG from m.d/mpt */


#ifdef MPT_0

#include "sys/jioctl.h"
#include "sys/ldterm.h"
#include "sys/ptem.h"
#include "sys/mspt.h"

int mspt_cnt = MPT_0_DEV;
struct mspt_ttys mspt_tty[MPT_0_DEV];

#endif

/* %CONFIG from m.d/S54K */


#ifdef S54K_0_FS

struct	buf	b4kfreelist;		/* head of the free list of buffers */
struct	buf	b4kdirtylist;		/* head of the list of dirty buffers */
struct	buf	bufhdrs4k[N4KBUF];	/* buffer headers */
char		*buffers4k;		/* pointer to buffer data */
int		s54knbuf = N4KBUF;
int		n4kinode = N4KINODE;
struct	s5inode	s54kinode[N4KINODE+1];	/* s54kinode table */
int		n4khbuf = N4KHBUF;	/* number of hash buffers */
struct buf	s54khbuf[N4KHBUF];	/* hash buffers */
int		s54khmask = S54KHMASK;
int		s54kbasynwait;
int		s54kbasyncnt;

S54K_malloc(nextclick)
int	nextclick;
{
	buffers4k = (char *)ctob(nextclick);
	return (nextclick + N4KBUF);
}

#else /* S54K_0_FS */

s54kbflush() {}
s54kbdflush()
{
	while (1)
		sleep(s54kbdflush);
}
s54kiodone_brelse() {}
S54K_malloc(x) int x; { return (x); }
s54kbdwait_timeout() { return (0); }

#endif /* S54K_0_FS */

/* %CONFIG from m.d/ldterm */


#ifdef LDTERM_0_STR

#include "sys/ldterm.h"

struct ldterm	ldterm_tty[NUM_LDTERM];
int		ldterm_cnt = sizeof(ldterm_tty) / sizeof(*ldterm_tty);

#endif /* LDTERM_0_STR */

/* %CONFIG from m.d/ptem */


struct { char a[0x1c]; } ptem[NPTEM];
int	ptem_cnt = sizeof(ptem) / sizeof(*ptem);

/* %CONFIG from m.d/timod */


#ifdef TIMOD_0_STR
struct tim_tim { long a,b,c; } tim_tim[NUM_TIMOD];
int	tim_cnt = sizeof(tim_tim) / sizeof(*tim_tim);
#endif

/* %CONFIG from m.d/tirdwr */


#ifdef TIRDWR_0_STR
struct trw_trw { long a,b,c; } trw_trw[NUM_TIRDWR];
int	trw_cnt = sizeof(trw_trw) / sizeof(*trw_trw);
#endif /* TIRDWR_0_STR */

/* system tables */

/*
 * the print func is used only by prdev, which
 * checks for NULL
 */
#define NULLPRINT	(int(*)())0

extern	nodev(), nulldev(), nostrat();
extern	rootstart(), rootopen(), rootclose(), rootread(), rootwrite(),
	rootioctl(), rootstrategy(), rootprint();
extern	mmread(), mmwrite(), mmioctl();
extern	_upkern_conopen(), _upkern_conclose(), _upkern_conread(),
	_upkern_conwrite(), _upkern_conioctl();
extern struct streamtab	spmtydvrinfo;
extern	_upkern_syopen(), _upkern_syread(), _upkern_sywrite(),
	_upkern_syioctl();
extern	_upkern_erropen(), _upkern_errclose(), _upkern_errread();
extern struct streamtab	spmlpdvrinfo;
extern	_upkern_prfread(), _upkern_prfwrite(), _upkern_prfioctl();
extern	_upkern_sarioctl();
extern	vdinit(), vdopen(), vdclose(), vdread(), vdwrite(), vdioctl(),
	vdstrategy(), vdprint();
extern struct streamtab	loginfo;
extern struct streamtab	spinfo;
extern struct streamtab	clninfo;
extern	mrinit(), mropen(), mrclose(), mrread(), mrwrite(), _upkern_mrioctl(),
	mrstrategy(), mrprint();
extern	satinit(), satopen(), satclose(), satread();
extern	secinit(), _upkern_secopen(), _upkern_secclose(), _upkern_secread(),
	_upkern_secwrite();
extern	iopm_init(), _upkern_iopm_open(), iopm_read(), iopm_write(),
	_upkern_iopm_ioctl();
extern	_upkern_iopmb_open(), _upkern_iopmb_close(), iopmb_read(),
	iopmb_write(), _upkern_iopmb_ioctl(), iopmb_strategy(), iopmb_print();
extern	iopms_start();
extern struct streamtab	iopms_info;
extern	iopmclninit();
extern struct streamtab	iopmclninfo;

struct bdevsw	bdevsw[] = {
/* 0*/ {rootopen, rootclose, rootstrategy, rootprint},
/* 1*/ {nodev, nodev, nostrat, NULLPRINT},
/* 2*/ {nodev, nodev, nostrat, NULLPRINT},
/* 3*/ {nodev, nodev, nostrat, NULLPRINT},
/* 4*/ {nodev, nodev, nostrat, NULLPRINT},
/* 5*/ {nodev, nodev, nostrat, NULLPRINT},
/* 6*/ {nodev, nodev, nostrat, NULLPRINT},
/* 7*/ {nodev, nodev, nostrat, NULLPRINT},
/* 8*/ {nodev, nodev, nostrat, NULLPRINT},
/* 9*/ {nodev, nodev, nostrat, NULLPRINT},
/*10*/ {nodev, nodev, nostrat, NULLPRINT},
/*11*/ {nodev, nodev, nostrat, NULLPRINT},
/*12*/ {nodev, nodev, nostrat, NULLPRINT},
/*13*/ {nodev, nodev, nostrat, NULLPRINT},
/*14*/ {nodev, nodev, nostrat, NULLPRINT},
/*15*/ {nodev, nodev, nostrat, NULLPRINT},
/*16*/ {nodev, nodev, nostrat, NULLPRINT},
/*17*/ {nodev, nodev, nostrat, NULLPRINT},
/*18*/ {nodev, nodev, nostrat, NULLPRINT},
/*19*/ {nodev, nodev, nostrat, NULLPRINT},
/*20*/ {nodev, nodev, nostrat, NULLPRINT},
/*21*/ {nodev, nodev, nostrat, NULLPRINT},
/*22*/ {nodev, nodev, nostrat, NULLPRINT},
/*23*/ {nodev, nodev, nostrat, NULLPRINT},
/*24*/ {nodev, nodev, nostrat, NULLPRINT},
/*25*/ {nodev, nodev, nostrat, NULLPRINT},
/*26*/ {nodev, nodev, nostrat, NULLPRINT},
/*27*/ {vdopen, vdclose, vdstrategy, vdprint},
/*28*/ {nodev, nodev, nostrat, NULLPRINT},
/*29*/ {nodev, nodev, nostrat, NULLPRINT},
/*30*/ {nodev, nodev, nostrat, NULLPRINT},
/*31*/ {nodev, nodev, nostrat, NULLPRINT},
/*32*/ {nodev, nodev, nostrat, NULLPRINT},
/*33*/ {nodev, nodev, nostrat, NULLPRINT},
/*34*/ {nodev, nodev, nostrat, NULLPRINT},
/*35*/ {nodev, nodev, nostrat, NULLPRINT},
/*36*/ {nodev, nodev, nostrat, NULLPRINT},
/*37*/ {nodev, nodev, nostrat, NULLPRINT},
/*38*/ {nodev, nodev, nostrat, NULLPRINT},
/*39*/ {nodev, nodev, nostrat, NULLPRINT},
/*40*/ {nodev, nodev, nostrat, NULLPRINT},
/*41*/ {nodev, nodev, nostrat, NULLPRINT},
/*42*/ {nodev, nodev, nostrat, NULLPRINT},
/*43*/ {nodev, nodev, nostrat, NULLPRINT},
/*44*/ {nodev, nodev, nostrat, NULLPRINT},
/*45*/ {nodev, nodev, nostrat, NULLPRINT},
/*46*/ {nodev, nodev, nostrat, NULLPRINT},
/*47*/ {nodev, nodev, nostrat, NULLPRINT},
/*48*/ {nodev, nodev, nostrat, NULLPRINT},
/*49*/ {nodev, nodev, nostrat, NULLPRINT},
/*50*/ {nodev, nodev, nostrat, NULLPRINT},
/*51*/ {nodev, nodev, nostrat, NULLPRINT},
/*52*/ {nodev, nodev, nostrat, NULLPRINT},
/*53*/ {nodev, nodev, nostrat, NULLPRINT},
/*54*/ {nodev, nodev, nostrat, NULLPRINT},
/*55*/ {nodev, nodev, nostrat, NULLPRINT},
/*56*/ {nodev, nodev, nostrat, NULLPRINT},
/*57*/ {nodev, nodev, nostrat, NULLPRINT},
/*58*/ {nodev, nodev, nostrat, NULLPRINT},
/*59*/ {nodev, nodev, nostrat, NULLPRINT},
/*60*/ {nodev, nodev, nostrat, NULLPRINT},
/*61*/ {nodev, nodev, nostrat, NULLPRINT},
/*62*/ {nodev, nodev, nostrat, NULLPRINT},
/*63*/ {nodev, nodev, nostrat, NULLPRINT},
/*64*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*65*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*66*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*67*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*68*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*69*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*70*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*71*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*72*/ {nodev, nodev, nostrat, NULLPRINT},
/*73*/ {nodev, nodev, nostrat, NULLPRINT},
/*74*/ {nodev, nodev, nostrat, NULLPRINT},
/*75*/ {nodev, nodev, nostrat, NULLPRINT},
/*76*/ {nodev, nodev, nostrat, NULLPRINT},
/*77*/ {nodev, nodev, nostrat, NULLPRINT},
/*78*/ {nodev, nodev, nostrat, NULLPRINT},
/*79*/ {nodev, nodev, nostrat, NULLPRINT},
/*80*/ {nodev, nodev, nostrat, NULLPRINT},
/*81*/ {nodev, nodev, nostrat, NULLPRINT},
/*82*/ {nodev, nodev, nostrat, NULLPRINT},
/*83*/ {nodev, nodev, nostrat, NULLPRINT},
/*84*/ {nodev, nodev, nostrat, NULLPRINT},
/*85*/ {nodev, nodev, nostrat, NULLPRINT},
/*86*/ {nodev, nodev, nostrat, NULLPRINT},
/*87*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*88*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*89*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*90*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*91*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*92*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*93*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*94*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*95*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*96*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*97*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*98*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*99*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy, iopmb_print},
/*100*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*101*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*102*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*103*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*104*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*105*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*106*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*107*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*108*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*109*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*110*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*111*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*112*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*113*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*114*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*115*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*116*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*117*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*118*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*119*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*120*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*121*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*122*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*123*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*124*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*125*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
/*126*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_strategy,
	iopmb_print},
};
bdevcnt = sizeof(bdevsw) / sizeof(*bdevsw);


#define STR	(struct streamtab *)0
#define TTy(x)	((struct tty *)(x))
#define TTY	TTy(-1)

struct cdevsw	cdevsw[] = {
/* 0*/ {rootopen, rootclose, rootread, rootwrite, rootioctl, TTY, STR},
/* 1*/ {nulldev, nulldev, mmread, mmwrite, mmioctl, TTY, STR},
/* 2*/ {_upkern_conopen, _upkern_conclose, _upkern_conread, _upkern_conwrite,
	_upkern_conioctl, TTY, STR},
/* 3*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/* 4*/ {nodev, nodev, nodev, nodev, nodev, TTY, &spmtydvrinfo},
/* 5*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/* 6*/ {_upkern_syopen, nulldev, _upkern_syread, _upkern_sywrite,
	_upkern_syioctl, TTY, STR},
/* 7*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/* 8*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/* 9*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*10*/ {_upkern_erropen, _upkern_errclose, _upkern_errread, nulldev, nulldev,
	TTY, STR},
/*11*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*12*/ {nodev, nodev, nodev, nodev, nodev, TTY, &spmlpdvrinfo},
/*13*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*14*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*15*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*16*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*17*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*18*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*19*/ {nulldev, nulldev, _upkern_prfread, _upkern_prfwrite, _upkern_prfioctl,
	TTY, STR},
/*20*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*21*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*22*/ {nulldev, nulldev, nulldev, nulldev, _upkern_sarioctl, TTY, STR},
/*23*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*24*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*25*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*26*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*27*/ {vdopen, vdclose, vdread, vdwrite, vdioctl, TTY, STR},
/*28*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*29*/ {nodev, nodev, nodev, nodev, nodev, TTY, &loginfo},
/*30*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*31*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*32*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*33*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*34*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*35*/ {nodev, nodev, nodev, nodev, nodev, TTY, &spinfo},
/*36*/ {nodev, nodev, nodev, nodev, nodev, TTY, &clninfo},
/*37*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*38*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*39*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*40*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*41*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*42*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*43*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*44*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*45*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*46*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*47*/ {satopen, satclose, satread, nulldev, nulldev, TTY, STR},
/*48*/ {_upkern_secopen, _upkern_secclose, _upkern_secread, _upkern_secwrite,
	nulldev, TTY, STR},
/*49*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*50*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*51*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*52*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*53*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*54*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*55*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*56*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*57*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*58*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*59*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*60*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*61*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*62*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*63*/ {_upkern_iopm_open, nulldev, iopm_read, iopm_write, _upkern_iopm_ioctl,
	TTY, STR},
/*64*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*65*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*66*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*67*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*68*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*69*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*70*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*71*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*72*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*73*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*74*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*75*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*76*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*77*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*78*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*79*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*80*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopmclninfo},
/*81*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*82*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*83*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*84*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*85*/ {nodev, nodev, nodev, nodev, nodev, TTY, &iopms_info},
/*86*/ {nodev, nodev, nodev, nodev, nodev, TTY, STR },
/*87*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*88*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*89*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*90*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*91*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*92*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*93*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*94*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*95*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*96*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*97*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*98*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*99*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*100*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*101*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*102*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*103*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*104*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*105*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*106*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*107*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*108*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*109*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*110*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*111*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*112*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*113*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*114*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*115*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*116*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*117*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*118*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*119*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*120*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*121*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*122*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*123*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*124*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*125*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
/*126*/ {_upkern_iopmb_open, _upkern_iopmb_close, iopmb_read, iopmb_write,
	_upkern_iopmb_ioctl, TTY, STR},
};
cdevcnt = sizeof(cdevsw) / sizeof(*cdevsw);


/* extended minor device offset array */

#define UM(maj)	notminored(maj * 256)

dev_t	MINOR[] = {
/*  0*/ UM(  0), UM(  1), UM(  2), UM(  3), UM(  4), UM(  5), UM(  6), UM(  7),
/*  8*/ UM(  8), UM(  9), UM( 10), UM( 11), UM( 12), UM( 13), UM( 14), UM( 15),
/* 16*/ UM( 16), UM( 17), UM( 18), UM( 19), UM( 20), UM( 21), UM( 22), UM( 23),
/* 24*/ UM( 24), UM( 25), UM( 26), UM( 27), UM( 28), UM( 29), UM( 30), UM( 31),
/* 32*/ UM( 32), UM( 33), UM( 34), UM( 35), UM( 36), UM( 37), UM( 38), UM( 39),
/* 40*/ UM( 40), UM( 41), UM( 42), UM( 43), UM( 44), UM( 45), UM( 46), UM( 47),
/* 48*/ UM( 48), UM( 49), UM( 50), UM( 51), UM( 52), UM( 53), UM( 54), UM( 55),
/* 56*/ UM( 56), UM( 57), UM( 58), UM( 59), UM( 60), UM( 61), UM( 62), UM( 63),
/* 64*/ UM( 64), UM( 64), UM( 64), UM( 64), UM( 64), UM( 64), UM( 64), UM( 64),
/* 72*/ UM( 72), UM( 72), UM( 72), UM( 72), UM( 72), UM( 72), UM( 72), UM( 72),
/* 80*/ UM( 80), UM( 73), UM( 73), UM( 73), UM( 73), UM( 73), UM( 86), UM( 79),
/* 88*/ UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79),
/* 96*/ UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79),
/*104*/ UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79),
/*112*/ UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79),
/*120*/ UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM( 79), UM(127)
};

/* major device group leader array */

char	GMAJOR[] = {
/*  0*/   0,   1,   2,   3,   4,   5,   6,   7,
/*  8*/   8,   9,  10,  11,  12,  13,  14,  15,
/* 16*/  16,  17,  18,  19,  20,  21,  22,  23,
/* 24*/  24,  25,  26,  27,  28,  29,  30,  31,
/* 32*/  32,  33,  34,  35,  36,  37,  38,  39,
/* 40*/  40,  41,  42,  43,  44,  45,  46,  47,
/* 48*/  48,  49,  50,  51,  52,  53,  54,  55,
/* 56*/  56,  57,  58,  59,  60,  61,  62,  63,
/* 64*/  64,  64,  64,  64,  64,  64,  64,  64,
/* 72*/  72,  72,  72,  72,  72,  72,  72,  72,
/* 80*/  80,  72,  72,  72,  72,  72,  86,  64,
/* 88*/  64,  64,  64,  64,  64,  64,  64,  64,
/* 96*/  64,  64,  64,  64,  64,  64,  64,  64,
/*104*/  64,  64,  64,  64,  64,  64,  64,  64,
/*112*/  64,  64,  64,  64,  64,  64,  64,  64,
/*120*/  64,  64,  64,  64,  64,  64,  64, 127
};

/* next major device in group array (-1 = end)*/

char	NMAJOR[] = {
/*  0*/  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
/*  8*/  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
/* 16*/  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
/* 24*/  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
/* 32*/  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
/* 40*/  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
/* 48*/  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
/* 56*/  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
/* 64*/  65,  66,  67,  68,  69,  70,  71,  87,
/* 72*/  73,  74,  75,  76,  77,  78,  79,  81,
/* 80*/  -1,  82,  83,  84,  85,  -1,  -1,  88,
/* 88*/  89,  90,  91,  92,  93,  94,  95,  96,
/* 96*/  97,  98,  99, 100, 101, 102, 103, 104,
/*104*/ 105, 106, 107, 108, 109, 110, 111, 112,
/*112*/ 113, 114, 115, 116, 117, 118, 119, 120,
/*120*/ 121, 122, 123, 124, 125, 126,  -1,  -1
};

/* mirror tables */


struct mr_devsw	mr_devsw[] = {
	0
};
uint	mr_devcnt = sizeof(mr_devsw) / sizeof(*mr_devsw);

/* mirror stubs */


/* system init, start, and powerfail tables */

int	(*pwr_clr[])() = {
	(int (*)())0
};

int	(*io_init[])() = {
	vdinit,
	mrinit,
	satinit,
	secinit,
	iopm_init,
	iopmclninit,
	(int (*)())0
};

int	(*io_start[])() = {
	rootstart,
	iopms_start,
	(int (*)())0
};

/* line disciplines */

extern	ttopen(), ttclose(), ttread(), ttwrite(), ttioctl(), ttin(), ttout();

struct linesw	linesw[] = {
/* 0*/ {ttopen, ttclose, ttread, ttwrite, ttioctl, ttin, ttout, nulldev},
};
linecnt = sizeof(linesw) / sizeof(*linesw);


/* stream modules */

extern struct streamtab	ldterminfo;
extern struct streamtab	pteminfo;
extern struct streamtab	timinfo;
extern struct streamtab	trwinfo;

struct fmodsw	fmodsw[] = {
/* 0*/ { "ldterm", &ldterminfo },
/* 1*/ { "ptem", &pteminfo },
/* 2*/ { "timod", &timinfo },
/* 3*/ { "tirdwr", &trwinfo },
};
int	fmodcnt = sizeof(fmodsw) / sizeof(*fmodsw);

/* file system switch externs */

extern int	fsstray();
extern inode_t	*fsinstray();

extern int s5init(), s5iput(), s5iupdat(), s5readi(), s5writei(), s5itrunc(),
	s5statf(), s5namei(), s5mount(), s5umount(), s5openi(), s5closei(),
	s5update(), s5statfs(), s5access(), s5getdents(), s5allocmap(),
	s5freemap(), s5readmap(), s5setattr(), s5notify(), s5fcntl(),
	s5ioctl();
extern inode_t *s5iread(), *s5getinode();

struct fsinfo	fsinfo[] = {
/* 0*/ { 0, (struct mount *)0, "", 0 },
/* 1*/ { 0, (struct mount *)0, "S51K", NO_SEEK },
};

struct fstypsw	fstypsw[] = {
/* 0*/ { fsstray, 0, fsstray, 0, fsinstray, 0, fsstray, 0, fsstray, 0,
	fsstray, 0, fsstray, 0, fsstray, 0, fsstray, 0, fsstray, 0, fsstray,
	0, fsstray, 0, fsinstray, 0, fsstray, 0, fsstray, 0, fsstray, 0,
	fsstray, 0, fsstray, 0, fsstray, 0, fsstray, 0, fsstray, 0, fsstray,
	0, fsstray, 0, fsstray, 0, fsstray, 0, fsstray, 0, fsstray, 0,
	fsstray, fsstray, fsstray, fsstray, fsstray },
/* 1*/ { s5init, 0, s5iput, FS_MULTIPROC, s5iread, FS_MULTIPROC, fsstray, 0,
	s5iupdat, FS_MULTIPROC, s5readi, FS_MULTIPROC, s5writei, FS_MULTIPROC,
	s5itrunc, FS_MULTIPROC, s5statf, FS_MULTIPROC, s5namei, FS_MULTIPROC,
	s5mount, 0, s5umount, 0, s5getinode, FS_MULTIPROC, s5openi,
	FS_MULTIPROC, s5closei, 0, s5update, FS_MULTIPROC, s5statfs, 0,
	s5access, FS_MULTIPROC, s5getdents, 0, s5allocmap, 0, s5freemap,
	FS_MULTIPROC, s5readmap, 0, s5setattr, FS_MULTIPROC, s5notify,
	FS_MULTIPROC, s5fcntl, FS_MULTIPROC, fsstray, 0, s5ioctl, 0, fsstray,
	fsstray, fsstray, fsstray, fsstray },
};
short	nfstyp = sizeof(fstypsw) / sizeof(*fstypsw);

/* upkern device functions */

static _upkern_conopen(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	conopen(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_conclose(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	conclose(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_conread(_minor_)
dev_t _minor_;
{
	upkern_lock();
	conread(_minor_);
	upkern_unlock();
}

static _upkern_conwrite(_minor_)
dev_t _minor_;
{
	upkern_lock();
	conwrite(_minor_);
	upkern_unlock();
}

static _upkern_conioctl(_minor_, _commnd_, _arg_, _flags_)
dev_t _minor_; int _commnd_, _arg_, _flags_;
{
	upkern_lock();
	conioctl(_minor_, _commnd_, _arg_, _flags_);
	upkern_unlock();
}

static _upkern_syopen(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	syopen(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_syread(_minor_)
dev_t _minor_;
{
	upkern_lock();
	syread(_minor_);
	upkern_unlock();
}

static _upkern_sywrite(_minor_)
dev_t _minor_;
{
	upkern_lock();
	sywrite(_minor_);
	upkern_unlock();
}

static _upkern_syioctl(_minor_, _commnd_, _arg_, _flags_)
dev_t _minor_; int _commnd_, _arg_, _flags_;
{
	upkern_lock();
	syioctl(_minor_, _commnd_, _arg_, _flags_);
	upkern_unlock();
}

static _upkern_erropen(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	erropen(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_errclose(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	errclose(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_errread(_minor_)
dev_t _minor_;
{
	upkern_lock();
	errread(_minor_);
	upkern_unlock();
}

static _upkern_prfread(_minor_)
dev_t _minor_;
{
	upkern_lock();
	prfread(_minor_);
	upkern_unlock();
}

static _upkern_prfwrite(_minor_)
dev_t _minor_;
{
	upkern_lock();
	prfwrite(_minor_);
	upkern_unlock();
}

static _upkern_prfioctl(_minor_, _commnd_, _arg_, _flags_)
dev_t _minor_; int _commnd_, _arg_, _flags_;
{
	upkern_lock();
	prfioctl(_minor_, _commnd_, _arg_, _flags_);
	upkern_unlock();
}

static _upkern_sarioctl(_minor_, _commnd_, _arg_, _flags_)
dev_t _minor_; int _commnd_, _arg_, _flags_;
{
	upkern_lock();
	sarioctl(_minor_, _commnd_, _arg_, _flags_);
	upkern_unlock();
}

static _upkern_mrioctl(_minor_, _commnd_, _arg_, _flags_)
dev_t _minor_; int _commnd_, _arg_, _flags_;
{
	upkern_lock();
	mrioctl(_minor_, _commnd_, _arg_, _flags_);
	upkern_unlock();
}

static _upkern_secopen(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	secopen(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_secclose(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	secclose(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_secread(_minor_)
dev_t _minor_;
{
	upkern_lock();
	secread(_minor_);
	upkern_unlock();
}

static _upkern_secwrite(_minor_)
dev_t _minor_;
{
	upkern_lock();
	secwrite(_minor_);
	upkern_unlock();
}

static _upkern_iopm_open(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	iopm_open(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_iopm_ioctl(_minor_, _commnd_, _arg_, _flags_)
dev_t _minor_; int _commnd_, _arg_, _flags_;
{
	upkern_lock();
	iopm_ioctl(_minor_, _commnd_, _arg_, _flags_);
	upkern_unlock();
}

static _upkern_iopmb_open(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	iopmb_open(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_iopmb_close(_minor_, _flags_, _op_typ_)
dev_t _minor_; int _flags_, _op_typ_;
{
	upkern_lock();
	iopmb_close(_minor_, _flags_, _op_typ_);
	upkern_unlock();
}

static _upkern_iopmb_ioctl(_minor_, _commnd_, _arg_, _flags_)
dev_t _minor_; int _commnd_, _arg_, _flags_;
{
	upkern_lock();
	iopmb_ioctl(_minor_, _commnd_, _arg_, _flags_);
	upkern_unlock();
}

